Compare commits

...
Author SHA1 Message Date
Serge Schneider aaaf0aea13 Update release notes 2017-08-14 15:33:06 +01:00
Serge Schneider c2db8285a1 Disable 64bit filesystem feature 2017-08-11 17:39:58 +01:00
Serge Schneider 3fe8d79947 Remove pulseaudio 2017-07-28 13:35:46 +01:00
Serge Schneider 8d40bc1bb4 stage3: Add gldriver-test 2017-07-28 13:35:46 +01:00
Serge Schneider 178b1e404b Remove NTP in favour of systemd-timesyncd 2017-07-28 13:35:46 +01:00
Serge Schneider f2060a8ee2 export-noobs: enable NOOBS config script here instead of stage2 2017-07-28 13:35:46 +01:00
Serge Schneider 7149e20f2d export-image: generate .info file 2017-07-28 13:35:46 +01:00
Serge Schneider 207003b5ed stage2: Move ssh host key regen and NOOBS config scripts to raspberrypi-sys-mods 2017-07-28 13:35:46 +01:00
Serge Schneider c77669ad9f stage2: firmware-ralink renamed to firmware-misc-nonfree 2017-07-28 13:35:46 +01:00
Serge Schneider 6618df4b08 stage2: update wait.conf 2017-07-28 13:35:46 +01:00
Serge Schneider 0f5f10d925 stage4: install liberation2 font 2017-07-28 13:35:46 +01:00
Serge Schneider 19fc4a367e stage2: Add htop 2017-07-28 13:35:46 +01:00
Serge Schneider 036e5242b3 stage2: Add libmtp-runtime and rsync 2017-07-28 13:35:46 +01:00
Serge Schneider 8f361a1c38 Switch to Stretch 2017-07-28 13:35:46 +01:00
Serge Schneider 68cdf34cb4 Add xz-utils dependency
Closes #90
2017-07-28 13:22:03 +01:00
TJ Rana 3441133d1c Corrected various typos (#91)
* Rename License.md to LICENSE

* Correct typos

* Clean up code layout

Organize layout with extra lines
2017-07-27 12:11:07 +02:00
Claus Strasburger fe45b73987 Added docker-compose.yml for easy apt-cacher-ng startup 2017-07-17 12:21:37 +02:00
Claus Strasburger bab0fe3b0d Docker build: move to debian stretch 2017-07-17 12:21:28 +02:00
Russ Kubes 4d65b2b357 Export-image: Only disable metadata_csum feature if it's possibly enabled. 2017-07-17 11:36:43 +02:00
Serge Schneider 137efd2379 Update release notes 2017-07-10 14:29:11 +01:00
Serge Schneider dd7de2554c Update release notes 2017-07-05 11:23:54 +01:00
Serge Schneider 234c4b7937 Export-image: disable metadata_csum for compatibility with older SD card copiers 2017-07-03 16:40:23 +01:00
Serge Schneider be2018ee5f README: Add stage 5 description 2017-06-27 13:16:41 +01:00
Andrew Smith cdf1cf2aba Also use -v in error message 2017-06-27 13:10:09 +01:00
Andrew Smith 22c4105b57 Tell docker to delete the volume as well
Addresses #62

Because of the use of volumes the .img files (and everything else) will stay around on disk even when you do `docker rm pigen_work`. Passing `-v` deletes the volume as well and frees up disk space.
2017-06-27 13:10:09 +01:00
Jacob Siverskog d2f88a6e4f Update stage specification example
The previous example failed for me due to a missing SKIP in
stage5. While at it, complete the example with all steps needed to get
an image generated.
2017-06-27 13:09:40 +01:00
Thomas Phillips c92638438a Fixed running docker script from within pwd containing spaces 2017-06-27 13:08:08 +01:00
Thomas Phillips 50e5c01f57 Image build date now honours timezone 2017-06-27 13:06:50 +01:00
Serge Schneider a0060bd475 export-image: increase free space padding 2017-06-21 10:56:07 +01:00
Serge Schneider d2b8d634b9 export-image: switch from fallocate to truncate 2017-06-21 10:46:10 +01:00
Serge Schneider d347d8d5f7 stage0: configure apt before locales 2017-06-21 08:55:30 +01:00
Serge Schneider 530b66fd3f bootstrap: cope with NFS and FUSE filesystems 2017-06-20 16:17:12 +01:00
Serge Schneider 02728fe65e export-image: use apparent size when calculating disk usage 2017-06-20 16:13:59 +01:00
Serge Schneider e583c18eba stage4: install python3-thonny 2017-06-20 16:12:32 +01:00
Serge Schneider 046db2d3d3 NOOBS: update kernel version number 2017-06-20 16:11:17 +01:00
Serge Schneider f9637fb24e Update release notes 2017-05-15 16:46:18 +01:00
Serge Schneider 921202e371 stage4: add /etc/mtab symlink 2017-05-15 16:40:31 +01:00
Serge Schneider dc7b589e7a Move rpi-update from stage3 to stage2 2017-05-15 15:46:59 +01:00
Serge Schneider 3c0b364028 stage0: Install locales
fixes #65
2017-05-15 14:48:25 +01:00
Serge Schneider 51f27e752c stage4: Add Thonny 2017-05-10 13:43:50 +01:00
Serge Schneider f89ebe2382 stage4: Add Scratch 2 2017-05-10 13:43:50 +01:00
Serge Schneider d64c21bfc9 stage4: Add pimoroni's packages 2017-05-10 13:43:50 +01:00
Ben Nuttall 7bbaac3344 Shorten config.txt url
Because why not? :)
2017-05-10 13:32:43 +01:00
Serge Schneider 8e377c407f stage0: Verify Releases during bootstrap
Fixes #5
2017-05-10 13:09:20 +01:00
Serge Schneider 4e5dc43a36 stage4: Install 'git' instead of transitional package 'git-core'
Fixes #11
2017-05-08 16:49:13 +01:00
T. Joseph Carter d729fc2dbb README.md: Describe more config variables, cleanup
Added some documentation of environment variables to README.md,
specifically WORK_DIR and DEPLOY_DIR.  Explicitly did not include
SCRIPT_DIR at this time because that appears to require some small work
before it can be changed.

Took the chance for some other syntax cleanups while I was at it, mostly
breaking long lines and inserting whitespace where some Markdown parsers
require it.
2017-05-08 16:25:04 +01:00
55 changed files with 255 additions and 131 deletions
+1
View File
@@ -5,3 +5,4 @@ postrun.sh
SKIP SKIP
.pc .pc
*-pc *-pc
apt-cacher-ng/
+2 -2
View File
@@ -1,10 +1,10 @@
FROM debian:jessie FROM debian:stretch
RUN apt-get -y update && \ RUN apt-get -y update && \
apt-get -y install \ apt-get -y install \
git vim parted \ git vim parted \
quilt realpath qemu-user-static debootstrap zerofree pxz zip dosfstools \ quilt realpath qemu-user-static debootstrap zerofree pxz zip dosfstools \
bsdtar libcap2-bin rsync grep \ bsdtar libcap2-bin rsync grep udev xz-utils \
&& rm -rf /var/lib/apt/lists/* && rm -rf /var/lib/apt/lists/*
COPY . /pi-gen/ COPY . /pi-gen/
View File
+75 -17
View File
@@ -1,12 +1,24 @@
# pi-gen # pi-gen
_Tool used to create the raspberrypi.org Raspbian images_ _Tool used to create the raspberrypi.org Raspbian images_
### TODO ### TODO
1. Documentation 1. Documentation
## Dependencies ## Dependencies
`quilt parted realpath qemu-user-static debootstrap zerofree pxz zip dosfstools bsdtar libcap2-bin grep rsync` On Debian-based systems:
```bash
apt-get install quilt parted realpath qemu-user-static debootstrap zerofree pxz zip \
dosfstools bsdtar libcap2-bin grep rsync xz-utils
```
The file `depends` contains a list of tools needed. The format of this
package is `<tool>[:<debian-package>]`.
## Config ## Config
@@ -29,29 +41,63 @@ The following environment variables are supported:
will not be included in the image, making it safe to use an `apt-cacher` or will not be included in the image, making it safe to use an `apt-cacher` or
similar package for development. similar package for development.
If you have Docker installed, you can set up a local apt caching proxy to
like speed up subsequent builds like this:
docker-compose up -d
echo 'APT_PROXY=http://172.17.0.1:3142' >> config
* `BASE_DIR` (Default: location of `build.sh`)
**CAUTION**: Currently, changing this value will probably break build.sh
Top-level directory for `pi-gen`. Contains stage directories, build
scripts, and by default both work and deployment directories.
* `WORK_DIR` (Default: `"$BASE_DIR/work"`)
Directory in which `pi-gen` builds the target system. This value can be
changed if you have a suitably large, fast storage location for stages to
be built and cached. Note, `WORK_DIR` stores a complete copy of the target
system for each build stage, amounting to tens of gigabytes in the case of
Raspbian.
* `DEPLOY_DIR` (Default: `"$BASE_DIR/deploy"`)
Output directory for target system images and NOOBS bundles.
A simple example for building Raspbian: A simple example for building Raspbian:
```bash ```bash
IMG_NAME='Raspbian' IMG_NAME='Raspbian'
``` ```
## Docker Build ## Docker Build
```bash ```bash
vi config # Edit your config file. See above. vi config # Edit your config file. See above.
./build-docker.sh ./build-docker.sh
``` ```
If everything goes well, your finished image will be in the `deploy/` folder. If everything goes well, your finished image will be in the `deploy/` folder.
You can then remove the build container with `docker rm pigen_work` You can then remove the build container with `docker rm -v pigen_work`
If something breaks along the line, you can edit the corresponding scripts, and If something breaks along the line, you can edit the corresponding scripts, and
continue: continue:
``` ```bash
CONTINUE=1 ./build-docker.sh CONTINUE=1 ./build-docker.sh
``` ```
There is a possibility that even when running from a docker container, the installation of `qemu-user-static` will silently fail when building the image because `binfmt-support` _must be enabled on the underlying kernel_. An easy fix is to ensure `binfmt-support` is installed on the host machine before starting the `./build-docker.sh` script (or using your own docker build solution). There is a possibility that even when running from a docker container, the
installation of `qemu-user-static` will silently fail when building the image
because `binfmt-support` _must be enabled on the underlying kernel_. An easy
fix is to ensure `binfmt-support` is installed on the host machine before
starting the `./build-docker.sh` script (or using your own docker build
solution).
## Stage Anatomy ## Stage Anatomy
@@ -86,11 +132,11 @@ maintenance and allows for more easy customization.
standard console hardware permission groups. standard console hardware permission groups.
There are a few tools that may not make a whole lot of sense here for There are a few tools that may not make a whole lot of sense here for
development purposes on a minimal system such as basic python and lua development purposes on a minimal system such as basic Python and Lua
packages as well as the `build-essential` package. They are lumped right packages as well as the `build-essential` package. They are lumped right
in with more essential packages presently, though they need not be with in with more essential packages presently, though they need not be with
pi-gen. These are understandable for Raspbian's target audience, but if pi-gen. These are understandable for Raspbian's target audience, but if
you were looking for something between truly minimal and Raspbian-lite, you were looking for something between truly minimal and Raspbian-Lite,
here's where you start trimming. here's where you start trimming.
- **Stage 3** - desktop system. Here's where you get the full desktop system - **Stage 3** - desktop system. Here's where you get the full desktop system
@@ -98,20 +144,32 @@ maintenance and allows for more easy customization.
enhancements, etc. This is a base desktop system, with some development enhancements, etc. This is a base desktop system, with some development
tools installed. tools installed.
- **Stage 4** - complete Raspbian system. More development tools, an email - **Stage 4** - Raspbian system meant to fit on a 4GB card. More development
client, learning tools like Scratch, specialized packages like sonic-pi and tools, an email client, learning tools like Scratch, specialized packages
wolfram-engine, system documentation, office productivity, etc. This is like sonic-pi, system documentation, office productivity, etc. This is the
the stage that installs all of the things that make Raspbian friendly to stage that installs all of the things that make Raspbian friendly to new
new users. users.
- **Stage 5** - The official Raspbian Desktop image. Right now only adds
Mathematica.
### Stage specification ### Stage specification
If you wish to build up to a specified stage (such as building up to stage 2 for a lite system), place an empty file named `SKIP` in each of the `./stage` directories you wish not to include.
Then remove the `EXPORT*` files from `./stage4` (if building up to stage 2) or from `./stage2` (if building a minimal system). If you wish to build up to a specified stage (such as building up to stage 2
for a lite system), place an empty file named `SKIP` in each of the `./stage`
directories you wish not to include.
``` Then remove the `EXPORT*` files from `./stage4` (if building up to stage 2) or
from `./stage2` (if building a minimal system).
```bash
# Example for building a lite system # Example for building a lite system
$ touch ./stage3/SKIP ./stage4/SKIP echo "IMG_NAME='Raspbian'" > config
$ rm stage4/EXPORT* touch ./stage3/SKIP ./stage4/SKIP ./stage5/SKIP
rm stage4/EXPORT*
sudo ./build.sh # or ./build-docker.sh
``` ```
If you wish to build further configurations upon (for example) the lite system, you can also delete the contents of `./stage3` and `./stage4` and replace with your own contents in the same format.
If you wish to build further configurations upon (for example) the lite
system, you can also delete the contents of `./stage3` and `./stage4` and
replace with your own contents in the same format.
+9 -5
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
DOCKER="docker" DOCKER="docker"
set +e set +e
$DOCKER ps >/dev/null 2>&1 $DOCKER ps >/dev/null 2>&1
@@ -12,9 +13,10 @@ if ! $DOCKER ps >/dev/null; then
fi fi
set -e set -e
config_mount=
config_mount=()
if [ -f config ]; then if [ -f config ]; then
config_mount="-v $(pwd)/config:/pi-gen/config:ro" config_mount=("-v" "$(pwd)/config:/pi-gen/config:ro")
source config source config
fi fi
@@ -45,7 +47,7 @@ fi
if [ "$CONTAINER_EXISTS" != "" ] && [ "$CONTINUE" != "1" ]; then if [ "$CONTAINER_EXISTS" != "" ] && [ "$CONTINUE" != "1" ]; then
echo "Container $CONTAINER_NAME already exists and you did not specify CONTINUE=1. Aborting." echo "Container $CONTAINER_NAME already exists and you did not specify CONTINUE=1. Aborting."
echo "You can delete the existing container like this:" echo "You can delete the existing container like this:"
echo " docker rm $CONTAINER_NAME" echo " docker rm -v $CONTAINER_NAME"
exit 1 exit 1
fi fi
@@ -54,6 +56,7 @@ if [ "$CONTAINER_EXISTS" != "" ]; then
trap "echo 'got CTRL+C... please wait 5s';docker stop -t 5 ${CONTAINER_NAME}_cont" SIGINT SIGTERM trap "echo 'got CTRL+C... please wait 5s';docker stop -t 5 ${CONTAINER_NAME}_cont" SIGINT SIGTERM
time $DOCKER run --rm --privileged \ time $DOCKER run --rm --privileged \
--volumes-from="${CONTAINER_NAME}" --name "${CONTAINER_NAME}_cont" \ --volumes-from="${CONTAINER_NAME}" --name "${CONTAINER_NAME}_cont" \
-e IMG_NAME=${IMG_NAME}\
pi-gen \ pi-gen \
bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static && bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static &&
cd /pi-gen; ./build.sh; cd /pi-gen; ./build.sh;
@@ -62,8 +65,9 @@ if [ "$CONTAINER_EXISTS" != "" ]; then
else else
trap "echo 'got CTRL+C... please wait 5s'; docker stop -t 5 ${CONTAINER_NAME}" SIGINT SIGTERM trap "echo 'got CTRL+C... please wait 5s'; docker stop -t 5 ${CONTAINER_NAME}" SIGINT SIGTERM
$DOCKER run --name "${CONTAINER_NAME}" --privileged \ $DOCKER run --name "${CONTAINER_NAME}" --privileged \
-v $(pwd)/deploy:/pi-gen/deploy \ -e IMG_NAME=${IMG_NAME}\
${config_mount} \ -v "$(pwd)/deploy:/pi-gen/deploy" \
"${config_mount[@]}" \
pi-gen \ pi-gen \
bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static && bash -e -o pipefail -c "dpkg-reconfigure qemu-user-static &&
cd /pi-gen; ./build.sh && cd /pi-gen; ./build.sh &&
+1 -1
View File
@@ -128,7 +128,7 @@ if [ -z "${IMG_NAME}" ]; then
exit 1 exit 1
fi fi
export IMG_DATE=${IMG_DATE:-"$(date -u +%Y-%m-%d)"} export IMG_DATE=${IMG_DATE:-"$(date +%Y-%m-%d)"}
export BASE_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)" export BASE_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)"
export SCRIPT_DIR="${BASE_DIR}/scripts" export SCRIPT_DIR="${BASE_DIR}/scripts"
+2 -1
View File
@@ -9,4 +9,5 @@ mkdosfs:dosfstools
capsh:libcap2-bin capsh:libcap2-bin
bsdtar bsdtar
grep grep
rsync rsync
xz:xz-utils
+10
View File
@@ -0,0 +1,10 @@
version: '2'
services:
apt-cacher-ng:
restart: unless-stopped
image: sameersbn/apt-cacher-ng:latest
ports:
- "3142:3142"
volumes:
- ./apt-cacher-ng:/var/cache/apt-cacher-ng
@@ -1,2 +1,3 @@
#!/bin/sh #!/bin/sh
exit 101 exit 101
@@ -3,7 +3,7 @@ Index: export-jessie/rootfs/etc/apt/sources.list.d/raspi.list
--- export-jessie.orig/rootfs/etc/apt/sources.list.d/raspi.list --- export-jessie.orig/rootfs/etc/apt/sources.list.d/raspi.list
+++ export-jessie/rootfs/etc/apt/sources.list.d/raspi.list +++ export-jessie/rootfs/etc/apt/sources.list.d/raspi.list
@@ -1,3 +1,3 @@ @@ -1,3 +1,3 @@
-deb http://archive.raspberrypi.org/debian/ jessie main ui staging -deb http://archive.raspberrypi.org/debian/ stretch main ui staging
+deb http://archive.raspberrypi.org/debian/ jessie main ui +deb http://archive.raspberrypi.org/debian/ stretch main ui
# Uncomment line below then 'apt-get update' to enable 'apt-get source' # Uncomment line below then 'apt-get update' to enable 'apt-get source'
#deb-src http://archive.raspberrypi.org/debian/ jessie main ui #deb-src http://archive.raspberrypi.org/debian/ stretch main ui
+1 -1
View File
@@ -1,3 +1,3 @@
#/bin/bash -e #!/bin/bash -e
install -m 644 files/resolv.conf ${ROOTFS_DIR}/etc/ install -m 644 files/resolv.conf ${ROOTFS_DIR}/etc/
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img" IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img"
IMGID="$(fdisk -l ${IMG_FILE} | sed -n 's/Disk identifier: 0x\([^ ]*\)/\1/p')" IMGID="$(fdisk -l ${IMG_FILE} | sed -n 's/Disk identifier: 0x\([^ ]*\)/\1/p')"
+23 -1
View File
@@ -1,6 +1,7 @@
#!/bin/bash -e #!/bin/bash -e
IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img" IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img"
INFO_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.info"
on_chroot << EOF on_chroot << EOF
/etc/init.d/fake-hwclock stop /etc/init.d/fake-hwclock stop
@@ -35,6 +36,8 @@ rm -f ${ROOTFS_DIR}/var/lib/dbus/machine-id
true > ${ROOTFS_DIR}/etc/machine-id true > ${ROOTFS_DIR}/etc/machine-id
ln -nsf /proc/mounts ${ROOTFS_DIR}/etc/mtab
for _FILE in $(find ${ROOTFS_DIR}/var/log/ -type f); do for _FILE in $(find ${ROOTFS_DIR}/var/log/ -type f); do
true > ${_FILE} true > ${_FILE}
done done
@@ -45,6 +48,24 @@ update_issue $(basename ${EXPORT_DIR})
install -m 644 ${ROOTFS_DIR}/etc/rpi-issue ${ROOTFS_DIR}/boot/issue.txt install -m 644 ${ROOTFS_DIR}/etc/rpi-issue ${ROOTFS_DIR}/boot/issue.txt
install files/LICENSE.oracle ${ROOTFS_DIR}/boot/ install files/LICENSE.oracle ${ROOTFS_DIR}/boot/
cp "$ROOTFS_DIR/etc/rpi-issue" "$INFO_FILE"
firmware=$(zgrep "firmware as of" "$ROOTFS_DIR/usr/share/doc/raspberrypi-kernel/changelog.Debian.gz" | \
head -n1 | \
sed -n 's|.* \([^ ]*\)$|\1|p')
printf "\nFirmware: https://github.com/raspberrypi/firmware/tree/%s\n" "$firmware" >> "$INFO_FILE"
kernel=$(curl -s -L "https://github.com/raspberrypi/firmware/raw/$firmware/extra/git_hash")
printf "Kernel: https://github.com/raspberrypi/linux/tree/%s\n" "$kernel" >> "$INFO_FILE"
uname=$(curl -s -L "https://github.com/raspberrypi/firmware/raw/$firmware/extra/uname_string7")
printf "Uname string: %s\n" "$uname" >> "$INFO_FILE"
printf "\nPackages:\n">> "$INFO_FILE"
dpkg -l --root "$ROOTFS_DIR" >> "$INFO_FILE"
ROOT_DEV=$(mount | grep "${ROOTFS_DIR} " | cut -f1 -d' ') ROOT_DEV=$(mount | grep "${ROOTFS_DIR} " | cut -f1 -d' ')
unmount ${ROOTFS_DIR} unmount ${ROOTFS_DIR}
@@ -56,7 +77,8 @@ mkdir -p ${DEPLOY_DIR}
rm -f ${DEPLOY_DIR}/image_${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.zip rm -f ${DEPLOY_DIR}/image_${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.zip
echo zip ${DEPLOY_DIR}/image_${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.zip ${IMG_FILE}
pushd ${STAGE_WORK_DIR} > /dev/null pushd ${STAGE_WORK_DIR} > /dev/null
zip ${DEPLOY_DIR}/image_${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.zip $(basename ${IMG_FILE}) zip ${DEPLOY_DIR}/image_${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.zip $(basename ${IMG_FILE})
popd > /dev/null popd > /dev/null
cp "$INFO_FILE" "$DEPLOY_DIR"
+12 -5
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img" IMG_FILE="${STAGE_WORK_DIR}/${IMG_DATE}-${IMG_NAME}${IMG_SUFFIX}.img"
unmount_image ${IMG_FILE} unmount_image ${IMG_FILE}
@@ -8,12 +9,12 @@ rm -f ${IMG_FILE}
rm -rf ${ROOTFS_DIR} rm -rf ${ROOTFS_DIR}
mkdir -p ${ROOTFS_DIR} mkdir -p ${ROOTFS_DIR}
BOOT_SIZE=$(du -s ${EXPORT_ROOTFS_DIR}/boot --block-size=1 | cut -f 1) BOOT_SIZE=$(du --apparent-size -s ${EXPORT_ROOTFS_DIR}/boot --block-size=1 | cut -f 1)
TOTAL_SIZE=$(du -s ${EXPORT_ROOTFS_DIR} --exclude var/cache/apt/archives --block-size=1 | cut -f 1) TOTAL_SIZE=$(du --apparent-size -s ${EXPORT_ROOTFS_DIR} --exclude var/cache/apt/archives --block-size=1 | cut -f 1)
IMG_SIZE=$((BOOT_SIZE + TOTAL_SIZE + (400 * 1024 * 1024))) IMG_SIZE=$((BOOT_SIZE + TOTAL_SIZE + (800 * 1024 * 1024)))
fallocate -l ${IMG_SIZE} ${IMG_FILE} truncate -s ${IMG_SIZE} ${IMG_FILE}
fdisk -H 255 -S 63 ${IMG_FILE} <<EOF fdisk -H 255 -S 63 ${IMG_FILE} <<EOF
o o
n n
@@ -50,8 +51,14 @@ ROOT_DEV=$(losetup --show -f -o ${ROOT_OFFSET} --sizelimit ${ROOT_LENGTH} ${IMG_
echo "/boot: offset $BOOT_OFFSET, length $BOOT_LENGTH" echo "/boot: offset $BOOT_OFFSET, length $BOOT_LENGTH"
echo "/: offset $ROOT_OFFSET, length $ROOT_LENGTH" echo "/: offset $ROOT_OFFSET, length $ROOT_LENGTH"
ROOT_FEATURES="^huge_file"
for FEATURE in metadata_csum 64bit; do
if grep -q "$FEATURE" /etc/mke2fs.conf; then
ROOT_FEATURES="^$FEATURE,$ROOT_FEATURES"
fi
done
mkdosfs -n boot -F 32 -v $BOOT_DEV > /dev/null mkdosfs -n boot -F 32 -v $BOOT_DEV > /dev/null
mkfs.ext4 -O ^huge_file $ROOT_DEV > /dev/null mkfs.ext4 -O $ROOT_FEATURES $ROOT_DEV > /dev/null
mount -v $ROOT_DEV ${ROOTFS_DIR} -t ext4 mount -v $ROOT_DEV ${ROOTFS_DIR} -t ext4
mkdir -p ${ROOTFS_DIR}/boot mkdir -p ${ROOTFS_DIR}/boot
+2 -2
View File
@@ -1,7 +1,7 @@
{ {
"description": "NOOBS_DESCRIPTION", "description": "NOOBS_DESCRIPTION",
"feature_level": 35120124, "feature_level": 35120124,
"kernel": "4.4", "kernel": "4.9",
"name": "NOOBS_NAME", "name": "NOOBS_NAME",
"password": "raspberry", "password": "raspberry",
"release_date": "UNRELEASED", "release_date": "UNRELEASED",
@@ -14,5 +14,5 @@
], ],
"url": "http://www.raspbian.org/", "url": "http://www.raspbian.org/",
"username": "pi", "username": "pi",
"version": "jessie" "version": "stretch"
} }
@@ -1,4 +1,29 @@
UNRELEASED: UNRELEASED:
* Based on Raspbian Stretch (Debian version 9)
* Version 60 of Chromium browser included
* Version 3.0.1 of Sonic Pi included
* Version 6.1.1 of RealVNC included
* Version 0.17.4 of NodeRED included
* Bluetooth audio routed via ALSA rather than Pulseaudio
* SenseHAT extension added to Scratch 2
* Various desktop applications modified to prompt for sudo password if needed
* lxinput control options for mouse speed simplified
* lxpanel plugins moved into separate packages
* Latest kernel and firmware
* Various small tweaks, bug fixes and theme modifications
2017-07-05:
* New kernel and firmware
* Filesystem created without the metadata_csum feature
2017-06-21:
* Scratch 2 application included
* Thonny Python IDE included
* New icons with thinner outlines
* Volume control more linear in behaviour
* Updated Flash player
* Updated RealVNC server and viewer
* Various tweaks and bugfixes
* New kernel and firmware
2017-04-10:
* Wolfram Mathematica updated to version 11.0.1 * Wolfram Mathematica updated to version 11.0.1
* Adobe Flash Player updated to version 25.0.0.127 * Adobe Flash Player updated to version 25.0.0.127
* Use PARTUUID to support USB boot * Use PARTUUID to support USB boot
+2
View File
@@ -31,6 +31,8 @@ mkdir -p ${NOOBS_DIR}
mount $ROOT_DEV ${STAGE_WORK_DIR}/rootfs mount $ROOT_DEV ${STAGE_WORK_DIR}/rootfs
mount $BOOT_DEV ${STAGE_WORK_DIR}/rootfs/boot mount $BOOT_DEV ${STAGE_WORK_DIR}/rootfs/boot
ln -sv "/lib/systemd/system/apply_noobs_os_config.service" "$ROOTFS_DIR/etc/systemd/system/multi-user.target.wants/apply_noobs_os_config.service"
bsdtar --format gnutar --use-compress-program pxz -C ${STAGE_WORK_DIR}/rootfs/boot -cpf ${NOOBS_DIR}/boot.tar.xz . bsdtar --format gnutar --use-compress-program pxz -C ${STAGE_WORK_DIR}/rootfs/boot -cpf ${NOOBS_DIR}/boot.tar.xz .
umount ${STAGE_WORK_DIR}/rootfs/boot umount ${STAGE_WORK_DIR}/rootfs/boot
bsdtar --format gnutar --use-compress-program pxz -C ${STAGE_WORK_DIR}/rootfs --one-file-system -cpf ${NOOBS_DIR}/root.tar.xz . bsdtar --format gnutar --use-compress-program pxz -C ${STAGE_WORK_DIR}/rootfs --one-file-system -cpf ${NOOBS_DIR}/root.tar.xz .
+3 -3
View File
@@ -16,9 +16,9 @@ bootstrap(){
fi fi
capsh --drop=cap_setfcap -- -c "${BOOTSTRAP_CMD} --components=main,contrib,non-free \ capsh --drop=cap_setfcap -- -c "${BOOTSTRAP_CMD} --components=main,contrib,non-free \
--arch armhf\ --arch armhf \
--no-check-gpg \ --keyring "${STAGE_DIR}/files/raspberrypi.gpg" \
$1 $2 $3" $1 $2 $3" || rmdir "$2/debootstrap"
} }
export -f bootstrap export -f bootstrap
+2 -2
View File
@@ -1,5 +1,5 @@
# dependencies_check # dependencies_check
# $@ Dependnecy files to check # $@ Dependency files to check
# #
# Each dependency is in the form of a tool to test for, optionally followed by # Each dependency is in the form of a tool to test for, optionally followed by
# a : and the name of a package if the package on a Debian-ish system is not # a : and the name of a package if the package on a Debian-ish system is not
@@ -21,7 +21,7 @@ dependencies_check()
done done
if [[ "$missing" ]]; then if [[ "$missing" ]]; then
echo "Reqired dependencies not installed" echo "Required dependencies not installed"
echo echo
echo "This can be resolved on Debian/Raspbian systems by installing:" echo "This can be resolved on Debian/Raspbian systems by installing:"
echo "$missing" echo "$missing"
+3
View File
@@ -0,0 +1,3 @@
deb http://archive.raspberrypi.org/debian/ stretch main ui staging
# Uncomment line below then 'apt-get update' to enable 'apt-get source'
#deb-src http://archive.raspberrypi.org/debian/ stretch main ui
@@ -0,0 +1,3 @@
deb http://mirrordirector.raspbian.org/raspbian/ stretch main contrib non-free rpi
# Uncomment line below then 'apt-get update' to enable 'apt-get source'
#deb-src http://archive.raspbian.org/raspbian/ stretch main contrib non-free rpi
-3
View File
@@ -1,3 +0,0 @@
deb http://archive.raspberrypi.org/debian/ jessie main ui staging
# Uncomment line below then 'apt-get update' to enable 'apt-get source'
#deb-src http://archive.raspberrypi.org/debian/ jessie main ui
@@ -1,3 +0,0 @@
deb http://mirrordirector.raspbian.org/raspbian/ jessie main contrib non-free rpi
# Uncomment line below then 'apt-get update' to enable 'apt-get source'
#deb-src http://archive.raspbian.org/raspbian/ jessie main contrib non-free rpi
File diff suppressed because one or more lines are too long
+1
View File
@@ -0,0 +1 @@
locales
Binary file not shown.
+2 -1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
bootstrap jessie ${ROOTFS_DIR} http://mirrordirector.raspbian.org/raspbian/ bootstrap stretch ${ROOTFS_DIR} http://mirrordirector.raspbian.org/raspbian/
fi fi
+1 -1
View File
@@ -1,5 +1,5 @@
# For more options and information see # For more options and information see
# http://rpf.io/configtxtreadme # http://rpf.io/configtxt
# Some settings may impact device functionality. See link above for details # Some settings may impact device functionality. See link above for details
# uncomment if you get no picture on HDMI for a default "safe" mode # uncomment if you get no picture on HDMI for a default "safe" mode
+1
View File
@@ -1,2 +1,3 @@
#!/bin/sh #!/bin/sh
exit 101 exit 101
@@ -1,13 +0,0 @@
Index: jessie-stage1/rootfs/lib/udev/rules.d/75-persistent-net-generator.rules
===================================================================
--- jessie-stage1.orig/rootfs/lib/udev/rules.d/75-persistent-net-generator.rules
+++ jessie-stage1/rootfs/lib/udev/rules.d/75-persistent-net-generator.rules
@@ -22,7 +22,7 @@ IMPORT{cmdline}="net.ifnames"
ENV{net.ifnames}=="1", GOTO="persistent_net_generator_end"
# device name whitelist
-KERNEL!="eth*|ath*|wlan*[0-9]|msh*|ra*|sta*|ctc*|lcs*|hsi*", \
+KERNEL!="ath*|msh*|ra*|sta*|ctc*|lcs*|hsi*", \
GOTO="persistent_net_generator_end"
# ignore Xen virtual interfaces
-1
View File
@@ -1,2 +1 @@
01-hosts.diff 01-hosts.diff
02-persistant-net.diff
-1
View File
@@ -1,7 +1,6 @@
#!/bin/bash -e #!/bin/bash -e
install -m 644 files/ipv6.conf ${ROOTFS_DIR}/etc/modprobe.d/ipv6.conf install -m 644 files/ipv6.conf ${ROOTFS_DIR}/etc/modprobe.d/ipv6.conf
install -m 644 files/interfaces ${ROOTFS_DIR}/etc/network/interfaces
install -m 644 files/hostname ${ROOTFS_DIR}/etc/hostname install -m 644 files/hostname ${ROOTFS_DIR}/etc/hostname
on_chroot << EOF on_chroot << EOF
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
copy_previous copy_previous
fi fi
File diff suppressed because one or more lines are too long
+6 -2
View File
@@ -1,4 +1,4 @@
ssh locales less fbset sudo psmisc strace module-init-tools ed ncdu crda ssh less fbset sudo psmisc strace ed ncdu crda
console-setup keyboard-configuration debconf-utils parted unzip console-setup keyboard-configuration debconf-utils parted unzip
build-essential manpages-dev python bash-completion gdb pkg-config build-essential manpages-dev python bash-completion gdb pkg-config
python-rpi.gpio v4l-utils python-rpi.gpio v4l-utils
@@ -6,7 +6,7 @@ avahi-daemon
lua5.1 lua5.1
luajit luajit
hardlink ca-certificates curl hardlink ca-certificates curl
fake-hwclock ntp nfs-common usbutils fake-hwclock nfs-common usbutils
libraspberrypi-dev libraspberrypi-doc libfreetype6-dev libraspberrypi-dev libraspberrypi-doc libfreetype6-dev
dosfstools dosfstools
dphys-swapfile dphys-swapfile
@@ -16,3 +16,7 @@ apt-listchanges
usb-modeswitch usb-modeswitch
apt-transport-https apt-transport-https
libpam-chksshpwd libpam-chksshpwd
rpi-update
libmtp-runtime
rsync
htop
-1
View File
@@ -2,5 +2,4 @@
02-swap.diff 02-swap.diff
04-inputrc.diff 04-inputrc.diff
05-path.diff 05-path.diff
06-rc_local.diff
07-resize-init.diff 07-resize-init.diff
+2 -3
View File
@@ -1,7 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
install -m 644 files/regenerate_ssh_host_keys.service ${ROOTFS_DIR}/lib/systemd/system/
install -m 755 files/apply_noobs_os_config ${ROOTFS_DIR}/etc/init.d/
install -m 755 files/resize2fs_once ${ROOTFS_DIR}/etc/init.d/ install -m 755 files/resize2fs_once ${ROOTFS_DIR}/etc/init.d/
install -d ${ROOTFS_DIR}/etc/systemd/system/rc-local.service.d install -d ${ROOTFS_DIR}/etc/systemd/system/rc-local.service.d
@@ -11,13 +9,14 @@ install -m 644 files/50raspi ${ROOTFS_DIR}/etc/apt/apt.conf.d/
install -m 644 files/console-setup ${ROOTFS_DIR}/etc/default/ install -m 644 files/console-setup ${ROOTFS_DIR}/etc/default/
install -m 755 files/rc.local ${ROOTFS_DIR}/etc/
on_chroot << EOF on_chroot << EOF
systemctl disable hwclock.sh systemctl disable hwclock.sh
systemctl disable nfs-common systemctl disable nfs-common
systemctl disable rpcbind systemctl disable rpcbind
systemctl disable ssh systemctl disable ssh
systemctl enable regenerate_ssh_host_keys systemctl enable regenerate_ssh_host_keys
systemctl enable apply_noobs_os_config
systemctl enable resize2fs_once systemctl enable resize2fs_once
EOF EOF
@@ -1,31 +0,0 @@
#!/bin/sh
### BEGIN INIT INFO
# Provides: apply_noobs_os_config
# Required-Start:
# Required-Stop:
# Default-Start: 2
# Default-Stop:
# Short-Description: Apply config from /boot/os_config.json
# Description:
### END INIT INFO
. /lib/lsb/init-functions
set -e
case "$1" in
start)
log_daemon_msg "Applying config from /boot/os_config.json (if it exists)"
if raspi-config --apply-os-config; then
update-rc.d apply_noobs_os_config remove
rm /etc/init.d/apply_noobs_os_config
log_end_msg 0
else
log_end_msg 1
fi
;;
*)
echo "Usage: $0 start" >&2
exit 3
;;
esac
+20
View File
@@ -0,0 +1,20 @@
#!/bin/sh -e
#
# rc.local
#
# This script is executed at the end of each multiuser runlevel.
# Make sure that the script will "exit 0" on success or any other
# value on error.
#
# In order to enable or disable this script just change the execution
# bits.
#
# By default this script does nothing.
# Print the IP address
_IP=$(hostname -I) || true
if [ "$_IP" ]; then
printf "My IP address is %s\n" "$_IP"
fi
exit 0
@@ -1,11 +0,0 @@
[Unit]
Description=Regenerate SSH host keys
[Service]
Type=oneshot
ExecStartPre=/bin/sh -c "if [ -e /dev/hwrng ]; then dd if=/dev/hwrng of=/dev/urandom count=1 bs=4096; fi"
ExecStart=/usr/bin/ssh-keygen -A
ExecStartPost=/bin/rm /lib/systemd/system/regenerate_ssh_host_keys.service ; /usr/sbin/update-rc.d regenerate_ssh_host_keys remove
[Install]
WantedBy=multi-user.target
+1 -1
View File
@@ -1,3 +1,3 @@
wpasupplicant wireless-tools firmware-atheros firmware-brcm80211 firmware-libertas firmware-ralink firmware-realtek wpasupplicant wireless-tools firmware-atheros firmware-brcm80211 firmware-libertas firmware-misc-nonfree firmware-realtek
raspberrypi-net-mods raspberrypi-net-mods
dhcpcd5 dhcpcd5
+1 -1
View File
@@ -1,3 +1,3 @@
[Service] [Service]
ExecStart= ExecStart=
ExecStart=/sbin/dhcpcd -q -w ExecStart=/usr/lib/dhcpcd5/dhcpcd -q -w
+1 -1
View File
@@ -1,2 +1,2 @@
NOOBS_NAME="Raspbian Lite" NOOBS_NAME="Raspbian Lite"
NOOBS_DESCRIPTION="A port of Debian jessie for the Raspberry Pi (minimal version)" NOOBS_DESCRIPTION="A port of Debian Stretch for the Raspberry Pi (minimal version)"
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
copy_previous copy_previous
fi fi
+2 -1
View File
@@ -1,10 +1,11 @@
gstreamer1.0-x gstreamer1.0-omx gstreamer1.0-plugins-base gstreamer1.0-plugins-good gstreamer1.0-plugins-bad gstreamer1.0-alsa gstreamer1.0-libav gstreamer1.0-x gstreamer1.0-omx gstreamer1.0-plugins-base gstreamer1.0-plugins-good gstreamer1.0-plugins-bad gstreamer1.0-alsa gstreamer1.0-libav
xpdf gtk2-engines alsa-utils xpdf gtk2-engines alsa-utils
desktop-base desktop-base
git-core rpi-update git
omxplayer omxplayer
raspberrypi-artwork raspberrypi-artwork
policykit-1 policykit-1
gvfs gvfs
rfkill rfkill
chromium-browser rpi-chromium-mods chromium-browser rpi-chromium-mods
gldriver-test
-1
View File
@@ -6,4 +6,3 @@ update-alternatives --install /usr/bin/x-www-browser \
update-alternatives --install /usr/bin/gnome-www-browser \ update-alternatives --install /usr/bin/gnome-www-browser \
gnome-www-browser /usr/bin/chromium-browser 86 gnome-www-browser /usr/bin/chromium-browser 86
EOF EOF
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
copy_previous copy_previous
fi fi
+4 -4
View File
@@ -8,11 +8,11 @@ python-serial python3-serial
python-picamera python3-picamera python-picamera python3-picamera
debian-reference-en dillo x2x debian-reference-en dillo x2x
raspberrypi-net-mods raspberrypi-ui-mods raspberrypi-net-mods raspberrypi-ui-mods
smartsim penguinspuzzle fonts-liberation2
smartsim
python-pip python3-pip python-pip python3-pip
python3-numpy python3-numpy
pypy pypy
python3-pifacecommon python3-pifacedigitalio python3-pifacedigital-scratch-handler python-pifacecommon python-pifacedigitalio
minecraft-pi python-minecraftpi minecraft-pi python-minecraftpi
alacarte rc-gui sense-hat alacarte rc-gui sense-hat
claws-mail claws-mail
@@ -23,13 +23,13 @@ nodered
libgl1-mesa-dri libgles1-mesa libgles2-mesa xcompmgr libgl1-mesa-dri libgles1-mesa libgles2-mesa xcompmgr
geany geany
piclone piclone
pulseaudio-module-bluetooth
wiringpi pigpio python-pigpio python3-pigpio raspi-gpio python-gpiozero python3-gpiozero python3-rpi.gpio wiringpi pigpio python-pigpio python3-pigpio raspi-gpio python-gpiozero python3-gpiozero python3-rpi.gpio
python-spidev python3-spidev python-spidev python3-spidev
python-twython python3-twython python-twython python3-twython
python-smbus python3-smbus python-smbus python3-smbus
python-flask python3-flask python-flask python3-flask
python-picraft python3-picraft python-picraft python3-picraft
python3-codebug-tether python3-codebug-i2c-tether
python-sense-emu python3-sense-emu sense-emu-tools python-sense-emu-doc python-sense-emu python3-sense-emu sense-emu-tools python-sense-emu-doc
pprompt pprompt
scratch2
python3-thonny
+19
View File
@@ -0,0 +1,19 @@
python-automationhat python3-automationhat
python-blinkt python3-blinkt
python-cap1xxx python3-cap1xxx
python-drumhat python3-drumhat
python-envirophat python3-envirophat
python-explorerhat python3-explorerhat
python-fourletterphat python3-fourletterphat
python-microdotphat python3-microdotphat
python-mote python3-mote
python-motephat python3-motephat
python-phatbeat python3-phatbeat
python-pianohat python3-pianohat
python-piglow python3-piglow
python-rainbowhat python3-rainbowhat
python-scrollphat python3-scrollphat
python-scrollphathd python3-scrollphathd
python-sn3218 python3-sn3218
python-skywriter python3-skywriter
python-touchphat python3-touchphat
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
copy_previous copy_previous
fi fi
+2 -2
View File
@@ -1,2 +1,2 @@
NOOBS_NAME="Raspbian with PIXEL" NOOBS_NAME="Raspbian"
NOOBS_DESCRIPTION="A port of Debian jessie for the Raspberry Pi (full desktop version)" NOOBS_DESCRIPTION="A port of Debian Stretch for the Raspberry Pi (full desktop version)"
+1
View File
@@ -1,4 +1,5 @@
#!/bin/bash -e #!/bin/bash -e
if [ ! -d ${ROOTFS_DIR} ]; then if [ ! -d ${ROOTFS_DIR} ]; then
copy_previous copy_previous
fi fi